/*****************************************************************************/
/*                    Announce utility for T-Fix                             */
/*                    (c)1996 by Dmitry Dyakonov                             */
/*****************************************************************************/

InFile=''; OutFile=''; SelFile=''
area.0=0; bytes.0=0; selectarea.0=0
Version='1.0'; SortOption='yes'
palka.1='|'; palka.2='/'; palka.3=''; palka.4='\'; pidx=1

say ; say 'Announce utility ver' Version 'for T-Fix'
parse arg InFile OutFile rest
If InFile='' | OutFile='' Then  call Usage
If stream(InFile,'c','open read') \= 'READY:' Then 
  call EndProgram "Can't open file:" InFile
do i=1 to words(rest)
  p=word(rest,i)
  select
     when p='?' | p='/?' | p='-?' then call Usage
     when translate(p)='/NS' then SortOption='no'
     when substr(p,1,1)='@' then
       do
          SelFile=strip(p,'l','@')
          If stream(SelFile,'c','open read') \= 'READY:' Then 
            call EndProgram "Can't open file:" SelFile
          call ReadSelect
       end
     otherwise do
                   selectarea.0=selectarea.0+1; i=selectarea.0;
                   selectarea.i=translate(p)
               end
  end
end
call ReadData
if area.0 \= 0 then
  do
     do i=1 to area.0
       bytes.0=bytes.0+1; bytes.i=0
        do j=1 to files.i.0
          bytes.i=bytes.i+word(files.i.j,2)
        end
     end
     if SortOption = 'no' then  say '  Sorting areas: disabled.'
     else  call SortFiles
     call Announce
  end
call EndProgram 'Thanks for using this program.'

ReadData:
  do while lines(InFile)
     str=strip(linein(InFile))
     if str = "" then iterate
     parse var str word rest
     parse upper var word word
     select 
       when word = "AREA"  then
          do
             if selectarea.0 \= 0 then
               do
                  if AreaCmp(word(rest,1))\=0 then
                  do
                     str=linein(InFile)  /* skip file record */
                     iterate
                  end
               end
             i=QueryExist(word(rest,1))
             if i=0 then
               do
                  area.0=area.0+1; i=area.0; area.i=rest; files.i.0=0
               end
          end    
       when word = "FILE"  then
          do
             files.i.0=files.i.0+1; j=files.i.0;
             files.i.j=translate(rest,'H','')
          end
       otherwise call lineout 'unknown.txt', str
     end
  end
  call stream InFile,'c','close'
return

QueryExist: procedure expose area.
 do i=1 to area.0
   if compare(translate(Arg(1)),translate(word(area.i,1)))=0 then return i
 end
return 0

ReadSelect: procedure expose SelFile selectarea.
 do while lines(SelFile)
   str=strip(linein(SelFile))
   if str = '' | substr(str,1,1) = ';' then iterate
   selectarea.0=selectarea.0+1; i=selectarea.0; selectarea.i=translate(str)
 end
 call stream SelFile,'c','close'
return

Announce:
 If stream(OutFile,'c','open write') \= 'READY:' Then 
   call EndProgram "Can't create/append file:" OutFile
 call lineout OutFile, ' Announce created at' time('c')',' date('l')
 call lineout OutFile, ''
 do i=1 to area.0
   call lineout OutFile, ' Area:' left(word(area.i,1),14,' ') 'Comment:' subword(area.i,2)
   call lineout OutFile, left(' ',79,'')
   call WriteArea
   call lineout OutFile, left(' ',79,'')
   call lineout OutFile, ' Total:' bytes.i 'bytes in' files.i.0 'files'
   call lineout OutFile, ''
 end
 call stream OutFile,'c','close'; say left('  Writing areas: done.',79)
return

AreaCmp: procedure expose selectarea.
 do i=1 to selectarea.0
  if MaskCmp(arg(1),selectarea.i) = 0 then return 0
 end
return 1

MaskCmp: procedure
 areaname=arg(1); mask=arg(2)
 do while(mask\='' | areaname\='')
   mchar=substr(mask,1,1)
   if mchar='*' then
     do
        mask=substr(mask,2)
        mchar=substr(mask,1,1)
        achar=substr(areaname,1,1)
        do while(achar\=' ' & achar\=mchar)
          areaname=substr(areaname,2)
          achar=substr(areaname,1,1)
        end
     end
   else
     do
        achar=substr(areaname,1,1)
        if mchar\=achar then return 1
        mask=substr(mask,2)
        areaname=substr(areaname,2)
     end
 end
return 0

SortFiles:
 do i=1 to area.0
   do j=1 to files.i.0
     do k=j+1 to files.i.0
        call charout ,left('  Sorting area:' word(area.i,1)  palka.pidx,79)''d2c(13)
        pidx=pidx+1; if pidx > 4 then pidx=1
       if word(files.i.j,1) > word(files.i.k,1) then
         do; str=files.i.j; files.i.j=files.i.k; files.i.k=str; end
     end
   end
 end; say left('  Sorting areas: done.',79)
return

WriteArea:
   do j=1 to files.i.0
     call charout ,left('  Writing area:' word(area.i,1)  palka.pidx,79)''d2c(13)
     pidx=pidx+1; if pidx > 4 then pidx=1
     parse var files.i.j fname fsize fdesc
     fdesc=strip(fdesc); str=''
     if length(fdesc) > 56 then
     do
        k=1; str=fdesc
        do while length(str)-length(subword(str,k)) < 54
          if length(str)-length(subword(str,k))+wordlength(str,k) > 54 then
            leave
          k=k+1
        end
        fdesc=subword(str,1,k-1)
     end
     call lineout OutFile, ' 'left(fname,12,' ') right(fsize,7,' ') fdesc
     str=subword(str,k)
     if length(str) > 0 then
     do
        do while length(str) > 56
          k=1
          do while length(str)-length(subword(str,k)) < 54
            if length(str)-length(subword(str,k))+wordlength(str,k) > 54 then
              leave
             k=k+1
           end
           call lineout OutFile,left('',21,' ') subword(str,1,k-1)
           str=subword(str,k)
         end
         call lineout OutFile,left('',21,' ') str
         str=''
     end
   end
return

Usage:
say 'Usage:  TFANN <infile> <outfile> [mask [mask]... @<selectfile>] [/ns]'
call EndProgram ''
return

EndProgram:
 say Arg(1); exit
return
